const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const inventory_items = sequelize.define(
    'inventory_items',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

item_kind: {
        type: DataTypes.ENUM,
      
      

        values: [

"avatar",


"cosmetic",


"title",


"badge"

        ],

      },

quantity: {
        type: DataTypes.INTEGER,
      
      

      },

unlocked_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  inventory_items.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity





































//end loop



    db.inventory_items.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });

    db.inventory_items.belongsTo(db.avatars, {
      as: 'avatar',
      foreignKey: {
        name: 'avatarId',
      },
      constraints: false,
    });

    db.inventory_items.belongsTo(db.cosmetics, {
      as: 'cosmetic',
      foreignKey: {
        name: 'cosmeticId',
      },
      constraints: false,
    });

    db.inventory_items.belongsTo(db.titles, {
      as: 'title_item',
      foreignKey: {
        name: 'title_itemId',
      },
      constraints: false,
    });

    db.inventory_items.belongsTo(db.badges, {
      as: 'badge',
      foreignKey: {
        name: 'badgeId',
      },
      constraints: false,
    });




    db.inventory_items.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.inventory_items.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return inventory_items;
};


